<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ClientCnxnSocketNIO.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper</a> &gt; <span class="el_source">ClientCnxnSocketNIO.java</span></div><h1>ClientCnxnSocketNIO.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.net.SocketAddress;
import java.nio.ByteBuffer;
import java.nio.channels.SelectionKey;
import java.nio.channels.Selector;
import java.nio.channels.SocketChannel;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;
import java.util.Set;

import org.apache.zookeeper.ClientCnxn.EndOfStreamException;
import org.apache.zookeeper.ClientCnxn.Packet;
import org.apache.zookeeper.ZooDefs.OpCode;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ClientCnxnSocketNIO extends ClientCnxnSocket {
<span class="fc" id="L40">    private static final Logger LOG = LoggerFactory</span>
<span class="fc" id="L41">            .getLogger(ClientCnxnSocketNIO.class);</span>

<span class="fc" id="L43">    private final Selector selector = Selector.open();</span>

    private SelectionKey sockKey;

    ClientCnxnSocketNIO() throws IOException {
<span class="fc" id="L48">        super();</span>
<span class="fc" id="L49">    }</span>

    @Override
    boolean isConnected() {
<span class="fc bfc" id="L53" title="All 2 branches covered.">        return sockKey != null;</span>
    }
    
    /**
     * @return true if a packet was received
     * @throws InterruptedException
     * @throws IOException
     */
    void doIO(List&lt;Packet&gt; pendingQueue, LinkedList&lt;Packet&gt; outgoingQueue, ClientCnxn cnxn)
      throws InterruptedException, IOException {
<span class="fc" id="L63">        SocketChannel sock = (SocketChannel) sockKey.channel();</span>
<span class="pc bpc" id="L64" title="1 of 2 branches missed.">        if (sock == null) {</span>
<span class="nc" id="L65">            throw new IOException(&quot;Socket is null!&quot;);</span>
        }
<span class="fc bfc" id="L67" title="All 2 branches covered.">        if (sockKey.isReadable()) {</span>
<span class="fc" id="L68">            int rc = sock.read(incomingBuffer);</span>
<span class="fc bfc" id="L69" title="All 2 branches covered.">            if (rc &lt; 0) {</span>
<span class="fc" id="L70">                throw new EndOfStreamException(</span>
                        &quot;Unable to read additional data from server sessionid 0x&quot;
<span class="fc" id="L72">                                + Long.toHexString(sessionId)</span>
                                + &quot;, likely server has closed socket&quot;);
            }
<span class="pc bpc" id="L75" title="1 of 2 branches missed.">            if (!incomingBuffer.hasRemaining()) {</span>
<span class="fc" id="L76">                incomingBuffer.flip();</span>
<span class="fc bfc" id="L77" title="All 2 branches covered.">                if (incomingBuffer == lenBuffer) {</span>
<span class="fc" id="L78">                    recvCount++;</span>
<span class="fc" id="L79">                    readLength();</span>
<span class="fc bfc" id="L80" title="All 2 branches covered.">                } else if (!initialized) {</span>
<span class="fc" id="L81">                    readConnectResult();</span>
<span class="fc" id="L82">                    enableRead();</span>
<span class="fc bfc" id="L83" title="All 2 branches covered.">                    if (findSendablePacket(outgoingQueue,</span>
<span class="fc" id="L84">                            cnxn.sendThread.clientTunneledAuthenticationInProgress()) != null) {</span>
                        // Since SASL authentication has completed (if client is configured to do so),
                        // outgoing packets waiting in the outgoingQueue can now be sent.
<span class="fc" id="L87">                        enableWrite();</span>
                    }
<span class="fc" id="L89">                    lenBuffer.clear();</span>
<span class="fc" id="L90">                    incomingBuffer = lenBuffer;</span>
<span class="fc" id="L91">                    updateLastHeard();</span>
<span class="fc" id="L92">                    initialized = true;</span>
                } else {
<span class="fc" id="L94">                    sendThread.readResponse(incomingBuffer);</span>
<span class="fc" id="L95">                    lenBuffer.clear();</span>
<span class="fc" id="L96">                    incomingBuffer = lenBuffer;</span>
<span class="fc" id="L97">                    updateLastHeard();</span>
                }
            }
        }
<span class="fc bfc" id="L101" title="All 2 branches covered.">        if (sockKey.isWritable()) {</span>
<span class="fc" id="L102">            synchronized(outgoingQueue) {</span>
<span class="fc" id="L103">                Packet p = findSendablePacket(outgoingQueue,</span>
<span class="fc" id="L104">                        cnxn.sendThread.clientTunneledAuthenticationInProgress());</span>

<span class="fc bfc" id="L106" title="All 2 branches covered.">                if (p != null) {</span>
<span class="fc" id="L107">                    updateLastSend();</span>
                    // If we already started writing p, p.bb will already exist
<span class="fc bfc" id="L109" title="All 2 branches covered.">                    if (p.bb == null) {</span>
<span class="fc bfc" id="L110" title="All 2 branches covered.">                        if ((p.requestHeader != null) &amp;&amp;</span>
<span class="fc bfc" id="L111" title="All 2 branches covered.">                                (p.requestHeader.getType() != OpCode.ping) &amp;&amp;</span>
<span class="fc bfc" id="L112" title="All 2 branches covered.">                                (p.requestHeader.getType() != OpCode.auth)) {</span>
<span class="fc" id="L113">                            p.requestHeader.setXid(cnxn.getXid());</span>
                        }
<span class="fc" id="L115">                        p.createBB();</span>
                    }
<span class="fc" id="L117">                    sock.write(p.bb);</span>
<span class="fc bfc" id="L118" title="All 2 branches covered.">                    if (!p.bb.hasRemaining()) {</span>
<span class="fc" id="L119">                        sentCount++;</span>
<span class="fc" id="L120">                        outgoingQueue.removeFirstOccurrence(p);</span>
<span class="fc bfc" id="L121" title="All 2 branches covered.">                        if (p.requestHeader != null</span>
<span class="fc bfc" id="L122" title="All 2 branches covered.">                                &amp;&amp; p.requestHeader.getType() != OpCode.ping</span>
<span class="fc bfc" id="L123" title="All 2 branches covered.">                                &amp;&amp; p.requestHeader.getType() != OpCode.auth) {</span>
<span class="fc" id="L124">                            synchronized (pendingQueue) {</span>
<span class="fc" id="L125">                                pendingQueue.add(p);</span>
<span class="pc" id="L126">                            }</span>
                        }
                    }
                }
<span class="fc bfc" id="L130" title="All 2 branches covered.">                if (outgoingQueue.isEmpty()) {</span>
                    // No more packets to send: turn off write interest flag.
                    // Will be turned on later by a later call to enableWrite(),
                    // from within ZooKeeperSaslClient (if client is configured
                    // to attempt SASL authentication), or in either doIO() or
                    // in doTransport() if not.
<span class="fc" id="L136">                    disableWrite();</span>
<span class="pc bpc" id="L137" title="2 of 6 branches missed.">                } else if (!initialized &amp;&amp; p != null &amp;&amp; !p.bb.hasRemaining()) {</span>
                    // On initial connection, write the complete connect request
                    // packet, but then disable further writes until after
                    // receiving a successful connection response.  If the
                    // session is expired, then the server sends the expiration
                    // response and immediately closes its end of the socket.  If
                    // the client is simultaneously writing on its end, then the
                    // TCP stack may choose to abort with RST, in which case the
                    // client would never receive the session expired event.  See
                    // http://docs.oracle.com/javase/6/docs/technotes/guides/net/articles/connection_release.html
<span class="fc" id="L147">                    disableWrite();</span>
                } else {
                    // Just in case
<span class="fc" id="L150">                    enableWrite();</span>
                }
<span class="fc" id="L152">            }</span>
        }
<span class="fc" id="L154">    }</span>

    private Packet findSendablePacket(LinkedList&lt;Packet&gt; outgoingQueue,
                                      boolean clientTunneledAuthenticationInProgress) {
<span class="fc" id="L158">        synchronized (outgoingQueue) {</span>
<span class="fc bfc" id="L159" title="All 2 branches covered.">            if (outgoingQueue.isEmpty()) {</span>
<span class="fc" id="L160">                return null;</span>
            }
<span class="fc bfc" id="L162" title="All 4 branches covered.">            if (outgoingQueue.getFirst().bb != null // If we've already starting sending the first packet, we better finish</span>
                || !clientTunneledAuthenticationInProgress) {
<span class="fc" id="L164">                return outgoingQueue.getFirst();</span>
            }

            // Since client's authentication with server is in progress,
            // send only the null-header packet queued by primeConnection().
            // This packet must be sent so that the SASL authentication process
            // can proceed, but all other packets should wait until
            // SASL authentication completes.
<span class="fc" id="L172">            ListIterator&lt;Packet&gt; iter = outgoingQueue.listIterator();</span>
<span class="fc bfc" id="L173" title="All 2 branches covered.">            while (iter.hasNext()) {</span>
<span class="fc" id="L174">                Packet p = iter.next();</span>
<span class="fc bfc" id="L175" title="All 2 branches covered.">                if (p.requestHeader == null) {</span>
                    // We've found the priming-packet. Move it to the beginning of the queue.
<span class="fc" id="L177">                    iter.remove();</span>
<span class="fc" id="L178">                    outgoingQueue.add(0, p);</span>
<span class="fc" id="L179">                    return p;</span>
                } else {
                    // Non-priming packet: defer it until later, leaving it in the queue
                    // until authentication completes.
<span class="pc bpc" id="L183" title="1 of 2 branches missed.">                    if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L184">                        LOG.debug(&quot;deferring non-priming packet: &quot; + p +</span>
                                &quot;until SASL authentication completes.&quot;);
                    }
                }
<span class="fc" id="L188">            }</span>
            // no sendable packet found.
<span class="fc" id="L190">            return null;</span>
<span class="nc" id="L191">        }</span>
    }

    @Override
    void cleanup() {
<span class="fc bfc" id="L196" title="All 2 branches covered.">        if (sockKey != null) {</span>
<span class="fc" id="L197">            SocketChannel sock = (SocketChannel) sockKey.channel();</span>
<span class="fc" id="L198">            sockKey.cancel();</span>
            try {
<span class="fc" id="L200">                sock.socket().shutdownInput();</span>
<span class="fc" id="L201">            } catch (IOException e) {</span>
<span class="pc bpc" id="L202" title="1 of 2 branches missed.">                if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L203">                    LOG.debug(&quot;Ignoring exception during shutdown input&quot;, e);</span>
                }
<span class="fc" id="L205">            }</span>
            try {
<span class="fc" id="L207">                sock.socket().shutdownOutput();</span>
<span class="fc" id="L208">            } catch (IOException e) {</span>
<span class="pc bpc" id="L209" title="1 of 2 branches missed.">                if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L210">                    LOG.debug(&quot;Ignoring exception during shutdown output&quot;,</span>
                            e);
                }
<span class="fc" id="L213">            }</span>
            try {
<span class="fc" id="L215">                sock.socket().close();</span>
<span class="nc" id="L216">            } catch (IOException e) {</span>
<span class="nc bnc" id="L217" title="All 2 branches missed.">                if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L218">                    LOG.debug(&quot;Ignoring exception during socket close&quot;, e);</span>
                }
<span class="fc" id="L220">            }</span>
            try {
<span class="fc" id="L222">                sock.close();</span>
<span class="nc" id="L223">            } catch (IOException e) {</span>
<span class="nc bnc" id="L224" title="All 2 branches missed.">                if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L225">                    LOG.debug(&quot;Ignoring exception during channel close&quot;, e);</span>
                }
<span class="fc" id="L227">            }</span>
        }
        try {
<span class="fc" id="L230">            Thread.sleep(100);</span>
<span class="nc" id="L231">        } catch (InterruptedException e) {</span>
<span class="nc bnc" id="L232" title="All 2 branches missed.">            if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L233">                LOG.debug(&quot;SendThread interrupted during sleep, ignoring&quot;);</span>
            }
<span class="fc" id="L235">        }</span>
<span class="fc" id="L236">        sockKey = null;</span>
<span class="fc" id="L237">    }</span>
 
    @Override
    void close() {
        try {
<span class="pc bpc" id="L242" title="1 of 2 branches missed.">            if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L243">                LOG.trace(&quot;Doing client selector close&quot;);</span>
            }
<span class="fc" id="L245">            selector.close();</span>
<span class="pc bpc" id="L246" title="1 of 2 branches missed.">            if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L247">                LOG.trace(&quot;Closed client selector&quot;);</span>
            }
<span class="nc" id="L249">        } catch (IOException e) {</span>
<span class="nc" id="L250">            LOG.warn(&quot;Ignoring exception during selector close&quot;, e);</span>
<span class="fc" id="L251">        }</span>
<span class="fc" id="L252">    }</span>
    
    /**
     * create a socket channel.
     * @return the created socket channel
     * @throws IOException
     */
    SocketChannel createSock() throws IOException {
        SocketChannel sock;
<span class="fc" id="L261">        sock = SocketChannel.open();</span>
<span class="fc" id="L262">        sock.configureBlocking(false);</span>
<span class="fc" id="L263">        sock.socket().setSoLinger(false, -1);</span>
<span class="fc" id="L264">        sock.socket().setTcpNoDelay(true);</span>
<span class="fc" id="L265">        return sock;</span>
    }

    /**
     * register with the selection and connect
     * @param sock the {@link SocketChannel} 
     * @param addr the address of remote host
     * @throws IOException
     */
    void registerAndConnect(SocketChannel sock, InetSocketAddress addr) 
    throws IOException {
<span class="fc" id="L276">        sockKey = sock.register(selector, SelectionKey.OP_CONNECT);</span>
<span class="fc" id="L277">        boolean immediateConnect = sock.connect(addr);</span>
<span class="pc bpc" id="L278" title="1 of 2 branches missed.">        if (immediateConnect) {</span>
<span class="nc" id="L279">            sendThread.primeConnection();</span>
        }
<span class="fc" id="L281">    }</span>
    
    @Override
    void connect(InetSocketAddress addr) throws IOException {
<span class="fc" id="L285">        SocketChannel sock = createSock();</span>
        try {
<span class="fc" id="L287">           registerAndConnect(sock, addr);</span>
<span class="fc" id="L288">        } catch (IOException e) {</span>
<span class="fc" id="L289">            LOG.error(&quot;Unable to open socket to &quot; + addr);</span>
<span class="fc" id="L290">            sock.close();</span>
<span class="fc" id="L291">            throw e;</span>
<span class="fc" id="L292">        }</span>
<span class="fc" id="L293">        initialized = false;</span>

        /*
         * Reset incomingBuffer
         */
<span class="fc" id="L298">        lenBuffer.clear();</span>
<span class="fc" id="L299">        incomingBuffer = lenBuffer;</span>
<span class="fc" id="L300">    }</span>

    /**
     * Returns the address to which the socket is connected.
     * 
     * @return ip address of the remote side of the connection or null if not
     *         connected
     */
    @Override
    SocketAddress getRemoteSocketAddress() {
        // a lot could go wrong here, so rather than put in a bunch of code
        // to check for nulls all down the chain let's do it the simple
        // yet bulletproof way
        try {
<span class="fc" id="L314">            return ((SocketChannel) sockKey.channel()).socket()</span>
<span class="fc" id="L315">                    .getRemoteSocketAddress();</span>
<span class="fc" id="L316">        } catch (NullPointerException e) {</span>
<span class="fc" id="L317">            return null;</span>
        }
    }

    /**
     * Returns the local address to which the socket is bound.
     * 
     * @return ip address of the remote side of the connection or null if not
     *         connected
     */
    @Override
    SocketAddress getLocalSocketAddress() {
        // a lot could go wrong here, so rather than put in a bunch of code
        // to check for nulls all down the chain let's do it the simple
        // yet bulletproof way
        try {
<span class="fc" id="L333">            return ((SocketChannel) sockKey.channel()).socket()</span>
<span class="fc" id="L334">                    .getLocalSocketAddress();</span>
<span class="fc" id="L335">        } catch (NullPointerException e) {</span>
<span class="fc" id="L336">            return null;</span>
        }
    }

    @Override
    synchronized void wakeupCnxn() {
<span class="fc" id="L342">        selector.wakeup();</span>
<span class="fc" id="L343">    }</span>
    
    @Override
    void doTransport(int waitTimeOut, List&lt;Packet&gt; pendingQueue, LinkedList&lt;Packet&gt; outgoingQueue,
                     ClientCnxn cnxn)
            throws IOException, InterruptedException {
<span class="fc" id="L349">        selector.select(waitTimeOut);</span>
        Set&lt;SelectionKey&gt; selected;
<span class="fc" id="L351">        synchronized (this) {</span>
<span class="fc" id="L352">            selected = selector.selectedKeys();</span>
<span class="pc" id="L353">        }</span>
        // Everything below and until we get back to the select is
        // non blocking, so time is effectively a constant. That is
        // Why we just have to do this once, here
<span class="fc" id="L357">        updateNow();</span>
<span class="fc bfc" id="L358" title="All 2 branches covered.">        for (SelectionKey k : selected) {</span>
<span class="fc" id="L359">            SocketChannel sc = ((SocketChannel) k.channel());</span>
<span class="fc bfc" id="L360" title="All 2 branches covered.">            if ((k.readyOps() &amp; SelectionKey.OP_CONNECT) != 0) {</span>
<span class="pc bpc" id="L361" title="1 of 2 branches missed.">                if (sc.finishConnect()) {</span>
<span class="fc" id="L362">                    updateLastSendAndHeard();</span>
<span class="fc" id="L363">                    sendThread.primeConnection();</span>
                }
<span class="pc bpc" id="L365" title="1 of 2 branches missed.">            } else if ((k.readyOps() &amp; (SelectionKey.OP_READ | SelectionKey.OP_WRITE)) != 0) {</span>
<span class="fc" id="L366">                doIO(pendingQueue, outgoingQueue, cnxn);</span>
            }
<span class="fc" id="L368">        }</span>
<span class="fc bfc" id="L369" title="All 2 branches covered.">        if (sendThread.getZkState().isConnected()) {</span>
<span class="fc" id="L370">            synchronized(outgoingQueue) {</span>
<span class="fc bfc" id="L371" title="All 2 branches covered.">                if (findSendablePacket(outgoingQueue,</span>
<span class="fc" id="L372">                        cnxn.sendThread.clientTunneledAuthenticationInProgress()) != null) {</span>
<span class="fc" id="L373">                    enableWrite();</span>
                }
<span class="fc" id="L375">            }</span>
        }
<span class="fc" id="L377">        selected.clear();</span>
<span class="fc" id="L378">    }</span>

    //TODO should this be synchronized?
    @Override
    void testableCloseSocket() throws IOException {
<span class="fc" id="L383">        LOG.info(&quot;testableCloseSocket() called&quot;);</span>
<span class="fc" id="L384">        ((SocketChannel) sockKey.channel()).socket().close();</span>
<span class="fc" id="L385">    }</span>

    @Override
    synchronized void enableWrite() {
<span class="fc" id="L389">        int i = sockKey.interestOps();</span>
<span class="fc bfc" id="L390" title="All 2 branches covered.">        if ((i &amp; SelectionKey.OP_WRITE) == 0) {</span>
<span class="fc" id="L391">            sockKey.interestOps(i | SelectionKey.OP_WRITE);</span>
        }
<span class="fc" id="L393">    }</span>

    @Override
    public synchronized void disableWrite() {
<span class="fc" id="L397">        int i = sockKey.interestOps();</span>
<span class="pc bpc" id="L398" title="1 of 2 branches missed.">        if ((i &amp; SelectionKey.OP_WRITE) != 0) {</span>
<span class="fc" id="L399">            sockKey.interestOps(i &amp; (~SelectionKey.OP_WRITE));</span>
        }
<span class="fc" id="L401">    }</span>

    synchronized private void enableRead() {
<span class="fc" id="L404">        int i = sockKey.interestOps();</span>
<span class="pc bpc" id="L405" title="1 of 2 branches missed.">        if ((i &amp; SelectionKey.OP_READ) == 0) {</span>
<span class="nc" id="L406">            sockKey.interestOps(i | SelectionKey.OP_READ);</span>
        }
<span class="fc" id="L408">    }</span>

    @Override
    synchronized void enableReadWriteOnly() {
<span class="fc" id="L412">        sockKey.interestOps(SelectionKey.OP_READ | SelectionKey.OP_WRITE);</span>
<span class="fc" id="L413">    }</span>

    Selector getSelector() {
<span class="nc" id="L416">        return selector;</span>
    }

    @Override
    void sendPacket(Packet p) throws IOException {
<span class="fc" id="L421">        SocketChannel sock = (SocketChannel) sockKey.channel();</span>
<span class="pc bpc" id="L422" title="1 of 2 branches missed.">        if (sock == null) {</span>
<span class="nc" id="L423">            throw new IOException(&quot;Socket is null!&quot;);</span>
        }
<span class="fc" id="L425">        p.createBB();</span>
<span class="fc" id="L426">        ByteBuffer pbb = p.bb;</span>
<span class="fc" id="L427">        sock.write(pbb);</span>
<span class="fc" id="L428">    }</span>


}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>